SystemOrganization addCategory: #'Reflect-Core'!
SystemOrganization addCategory: #'Reflect-Core-Tests'!

ALApplication subclass: #ImageReflector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflect-Core'!

!ImageReflector commentStamp: 'fbs 7/27/2012 19:04' prior: 0!
I provide a RESTful HTTP interface to reflect on the image in which I am defined.

My various resources consume and produce JSON.!

!ImageReflector class methodsFor: 'instance creation' stamp: 'fbs 7/28/2012 17:45'!
new
	^ self withLocator: (ParamLocator new)! !

!ImageReflector methodsFor: 'initialize-release' stamp: 'fbs 7/30/2012 23:21'!
initializeHandler
	handler := ALChunkingRelay destination: handler.
	handler := ALKeepAliveRelay destination: handler.
	handler := ALRequestDecodingRelay destination: handler.
	handler := ALLimitingRelay destination: handler! !

Object subclass: #MethodInspector
	instanceVariableNames: 'selector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflect-Core'!

MethodInspector subclass: #ClassLimitedImplementorsOf
	instanceVariableNames: 'class'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflect-Core'!

!ClassLimitedImplementorsOf class methodsFor: 'instance creation' stamp: 'fbs 7/30/2012 20:52'!
reflecting: aSelector onClass: aClass
	^ self basicNew initializeWithSelector: aSelector onClass: aClass.! !

!ClassLimitedImplementorsOf methodsFor: 'private' stamp: 'fbs 7/30/2012 21:07'!
findMethods
	^ #().! !

!ClassLimitedImplementorsOf methodsFor: 'initialize-release' stamp: 'fbs 7/30/2012 20:51'!
initializeWithSelector: aSelector onClass: aClass
	selector := aSelector.
	class := aClass.! !

!ClassLimitedImplementorsOf methodsFor: 'private' stamp: 'fbs 7/30/2012 21:06'!
title
	^ 'class-implementors-of'.! !

MethodInspector subclass: #ImplementorsOf
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflect-Core'!

!ImplementorsOf commentStamp: 'fbs 7/30/2012 20:50' prior: 0!
Show all implementors in an image of some selector.!

!ImplementorsOf class methodsFor: 'instance creation' stamp: 'fbs 7/29/2012 17:02'!
reflecting: aSelector
	^ self new initializeWithSelector: aSelector.! !

!ImplementorsOf methodsFor: 'private' stamp: 'fbs 7/30/2012 20:47'!
findMethods
	^ SystemNavigation default allImplementorsOf: selector! !

!ImplementorsOf methodsFor: 'private' stamp: 'fbs 7/30/2012 20:47'!
title
	^ 'implementors-of'.! !

!MethodInspector methodsFor: 'converting' stamp: 'fbs 7/30/2012 20:24'!
asResource
	^ ALJsonResource endpoint: self! !

!MethodInspector methodsFor: 'private' stamp: 'fbs 7/30/2012 20:44'!
findMethods
	self subclassResponsibility.! !

!MethodInspector methodsFor: 'initialize-release' stamp: 'fbs 7/30/2012 23:30'!
initializeWithSelector: aSelector
	self initialize.
	selector := aSelector! !

!MethodInspector methodsFor: 'as yet unclassified' stamp: 'fbs 7/30/2012 20:39'!
renderOn: json
	(MethodSet methods: self findMethods named: self title)
		renderOn: json.! !

!MethodInspector methodsFor: 'accessing' stamp: 'fbs 7/30/2012 20:27'!
selector
	^ selector! !

!MethodInspector methodsFor: 'private' stamp: 'fbs 7/30/2012 20:45'!
title
	self subclassResponsibility.! !

MethodInspector subclass: #SendersOf
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflect-Core'!

!SendersOf commentStamp: 'fbs 7/30/2012 20:50' prior: 0!
Show all senders in the image of some selector.!

!SendersOf class methodsFor: 'instance creation' stamp: 'fbs 7/27/2012 19:07'!
reflecting: aSelector
	^ self new initializeWithSelector: aSelector.! !

!SendersOf methodsFor: 'private' stamp: 'fbs 7/30/2012 20:46'!
findMethods
	^ SystemNavigation default allCallsOn: selector.! !

!SendersOf methodsFor: 'private' stamp: 'fbs 7/30/2012 20:46'!
title
	^ 'senders-of'! !

Object subclass: #MethodSet
	instanceVariableNames: 'setName methods'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflect-Core'!

!MethodSet class methodsFor: 'instance creation' stamp: 'fbs 7/30/2012 09:26'!
methods: someMethods named: aString
	^ self basicNew initializeWithMethods: someMethods named: aString.! !

!MethodSet methodsFor: 'initialize-release' stamp: 'fbs 7/30/2012 09:26'!
initializeWithMethods: someMethods named: aString
	self initialize.
	setName := aString.
	methods := someMethods.! !

!MethodSet methodsFor: 'printing' stamp: 'fbs 7/30/2012 09:33'!
renderOn: json
	json object: [
		json
			name: setName
			array: [methods do: [:mref |
				json object: [
					json name: 'class' value: mref actualClass name.
					json name: 'source' value: mref sourceCode asString]]]]! !

ALLocator subclass: #ParamLocator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflect-Core'!

!ParamLocator commentStamp: 'fbs 7/28/2012 17:03' prior: 0!
I act like a normal locator, except that I use the last part of an ALPath as a parameterised value.!

!ParamLocator methodsFor: 'private' stamp: 'fbs 7/28/2012 17:13'!
keyForResource: aResource
	^ aResource selector asString! !

!ParamLocator methodsFor: 'public' stamp: 'fbs 7/30/2012 21:05'!
resourceForPath: aPath
	^ aPath first
		caseOf: {
			['senders-of'] -> [(SendersOf reflecting: aPath second asSymbol) asResource].
			['implementors-of'] -> [(ImplementorsOf reflecting: aPath second asSymbol) asResource].
			['class-implementors-of'] -> [(ClassLimitedImplementorsOf
				reflecting: aPath third onClass: aPath second asSymbol) asResource]}
		otherwise: [ALNotFound signal: aPath printString].! !

TestCase subclass: #ParamLocatorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflect-Core-Tests'!
